#import "MainImageView.h"

@implementation MainImageView

-(void)awakeFromNib
{
	[self loadImageFromPath:@"~/Desktop/Deep_Jungle.jpg"];
}

-(void)drawRect:(NSRect)rect
{
	NSLog(@"redrawing now...");
	CIContext *context = [[NSGraphicsContext currentContext] CIContext];
    CGRect     cg = CGRectMake(NSMinX(rect), NSMinY(rect), NSWidth(rect), NSHeight(rect));
	//mainImage = [CIImage imageWithContentsOfURL:[NSURL fileURLWithPath:@"~/Desktop/242719UAcy_w.jpg"]];
	if (mainImage == nil) {
		NSLog(@"nil main image!");
	}
	[context drawImage:mainImage inRect:cg fromRect:cg];
}

-(void)loadImageFromPath:(NSString *)aPath
{
	if(mainImage != nil)
		[mainImage release];
	
	NSURL *url = [NSURL fileURLWithPath:[aPath stringByStandardizingPath]];
	NSLog([url absoluteString]);
	CIImage *currentImage = [CIImage imageWithContentsOfURL:url];
	//if (currentImage == nil) {
	//	NSLog(@"failed to initialize the image");
	//}
	mainImage = currentImage;

	CGRect mainImageSize = [mainImage extent];
	NSRect frame = [self bounds];
	[self setFrame:NSMakeRect(frame.origin.x, frame.origin.y, [mainImage extent].size.width, [mainImage extent].size.height)];
	[self setBoundsSize:NSMakeSize(mainImageSize.size.width, mainImageSize.size.height)];
	[self setNeedsDisplay:YES];
	
}

-(IBAction)selectNewImage:(id)sender
{
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	if ([openPanel runModal] == NSOKButton) {
		NSLog([openPanel filename]);
		NSString *fileLocation = [openPanel filename];
		[self loadImageFromPath:fileLocation];
	}
}

@end
